SIMPLER_ANIMAL_SETUP("sarbysonictwo", "WALK", "RUN_", "PAIN", "WAIT", "ROLL", "SPNG", "RIDE", "EDGE", "FALL", "SPDA", "DASH", "SKID")
SIMPLER_ANIMAL_SETUP("sarbyknucklestwo", "WALK", "RUN_", "PAIN", "WAIT", "ROLL", "SPNG", "RIDE", "EDGE", "FALL", "SPDA", "DASH", "SKID", "GLID", "SWIM") -- Initiate character and custom Sprite2s.


local helpers = _G["SIMPLER_ANIMAL_HELPERS"]

addHook("PlayerSpawn", function(sarbyluas) 
    if sarbyluas.mo.skin == "sarbysonictwo" or sarbyluas.mo.skin == "sarbyknucklestwo" then
	sarbyluas.jumped = false
	sarbyluas.snickthokked = false
	sarbyluas.knuckleglided = false
	sarbyluas.thokspeed = 1
	sarbyluas.waittimer = 150
	sarbyluas.springmode = false
	sarbyluas.yourefallingnow = false
	end
end)

freeslot("SKINCOLOR_SARBYSONICTWO", "SKINCOLOR_SARBYKNUXTWO")

skincolors[SKINCOLOR_SARBYSONICTWO] = {
    name = "SRB2Sonic",
    ramp = {146,147,148,149,150,151,152,153,154,155,156,157,158,159,253,254},
    accessible = false
}

skincolors[SKINCOLOR_SARBYKNUXTWO] = {
    name = "SRB2Knuckles",
    ramp = {210,32,33,34,35,35,36,37,38,39,41,43,45,45,46,47},
    accessible = false
}

function SIMPLER_ANIMAL_HOOKS.srb2_hhook(mobj)
  if helpers.getSkin(mobj) == "sarbysonictwo"
    local player = helpers.getPlayer(mobj)
	local machthreespeed = (K_GetKartSpeed(player, false, true) * 15) / 20
	local speedthreshold = player.mo.scale / 8
    

	player.waittimer = $ - 1
	player.mo.spriteyscale = FRACUNIT
	player.mo.spritexscale = FRACUNIT
	
	if player.speed >= 1 or helpers.isAirborne(mobj)
		player.waittimer = 150
	end
    for i = 0,108 do
      S_StopSoundByID(mobj, sfx_krta00 + i) -- Stop engine sounds.
    end
    
    if mobj.sprite2 == SPR2_GOAL then return
	elseif mobj.sprite2 == SPR2_DEAD then return
	elseif mobj.sprite2 == SPR2_SPIN then return "PAIN", A, A, A
	elseif (player.cmd.buttons & BT_BRAKE and player.cmd.buttons & BT_ACCELERATE and not (player.cmd.buttons & BT_DRIFT) and player.speed < 1) then return "STIN", A, A, A
    elseif player.spindash then return "SPIN", A, A, D
    elseif player.rideroid then return "RIDE", A, A, A
    elseif player.waittimer <= 0 then helpers.SquaredSlow(mobj, -1) return "WAIT", A, A, F
    elseif player.pullup then return "RIDE", A, A, A
    elseif player.jumped or player.dlzrocket then return "ROLL", A, A, F
    elseif player.respawn.timer or helpers.isTricking(mobj) or player.fastfall then
      helpers.SquaredSlow(mobj, -1)
      return "ROLL", A, A, F
	elseif player.respawn.dropdash then
      helpers.SquaredSlow(mobj, -1)
      return "FALL", A, A, B
	elseif helpers.isAscending(mobj) and player.springmode then
		helpers.SquaredSlow(mobj, -1)
		return "SPNG", A, A, A
	elseif helpers.isDescending(mobj) and player.springmode then
		helpers.SquaredSlow(mobj, -1)
		return "FALL", A, A, B
    elseif mobj.sprite2 == SPR2_DRLN or mobj.sprite2 == SPR2_DRRN -- Slowable drift.
      helpers.SquaredSlow(mobj, -1)
      return "SPIN", A, A, D
	elseif (player.cmd.buttons & BT_BRAKE) and helpers.isMovingForward(mobj) and not helpers.isAirborne(mobj) then
		helpers.SquaredSlow(mobj, -1)
		return "SKID", A, A, A
	elseif ((player.speed >= machthreespeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
		helpers.SquaredSlow(mobj, -1)
		return "RUN_", A, A, D
	elseif helpers.isAirborne(mobj) and((player.speed <= machthreespeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
		helpers.SquaredSlow(mobj, -1)
		return "WALK", A, A, H
	elseif helpers.isAirborne(mobj) and((player.speed >= machthreespeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
		helpers.SquaredSlow(mobj, -1)
		return "RUN_", A, A, D
	elseif mobj.sprite2 == SPR2_SLWN then
		if helpers.isMovingForward(mobj) then
			helpers.SquaredSlow(mobj, -1)
			return "WALK", A, A, H
		else -- Moving sideways/backwards.
			if helpers.isMovingBackward(mobj) then
				helpers.SquaredSlow(mobj, 1)
				return "WALK", H, H, A
			end
		end
	elseif mobj.sprite2 == SPR2_STIL or player.ebrake then return "STIN", A, A, A
	end
  end
end

function SIMPLER_ANIMAL_HOOKS.srb2knuckle_hhook(mobj)
  if helpers.getSkin(mobj) == "sarbyknucklestwo"
    local player = helpers.getPlayer(mobj)
	local machthreespeed = (K_GetKartSpeed(player, false, true) * 15) / 20
	local speedthreshold = player.mo.scale / 8
    
	player.waittimer = $ - 1
	player.mo.spriteyscale = FRACUNIT
	player.mo.spritexscale = FRACUNIT
	
	if player.speed >= 1 or helpers.isAirborne(mobj)
		player.waittimer = 150
	end
    for i = 0,108 do
      S_StopSoundByID(mobj, sfx_krta00 + i) -- Stop engine sounds.
    end
    
    if mobj.sprite2 == SPR2_GOAL then return
	elseif mobj.sprite2 == SPR2_DEAD then return
	elseif mobj.sprite2 == SPR2_SPIN then return "PAIN", A, A, A
	elseif (player.cmd.buttons & BT_BRAKE and player.cmd.buttons & BT_ACCELERATE and not (player.cmd.buttons & BT_DRIFT) and player.speed < 1) then return "STIN", A, A, A
    elseif player.spindash then return "SPIN", A, A, D
    elseif player.rideroid then return "RIDE", A, A, A
    elseif player.waittimer <= 0 then helpers.SquaredSlow(mobj, -1) return "WAIT", A, A, F
    elseif player.pullup then return "RIDE", A, A, A
	elseif player.knuckleglided and (player.mo.eflags & MFE_UNDERWATER) then helpers.SquaredSlow(mobj, -1) return "SWIM", A, A, H
    elseif player.knuckleglided then return "GLID", A, A, B
    elseif player.yourefallingnow then return "FALL", A, A, B
    elseif player.jumped or player.dlzrocket then return "ROLL", A, A, F
    elseif player.respawn.timer or helpers.isTricking(mobj) or player.fastfall then
      helpers.SquaredSlow(mobj, -1)
      return "ROLL", A, A, F
	elseif player.respawn.dropdash then
      helpers.SquaredSlow(mobj, -1)
      return "FALL", A, A, B
	elseif helpers.isAscending(mobj) and player.springmode then
		helpers.SquaredSlow(mobj, -1)
		return "SPNG", A, A, A
	elseif helpers.isDescending(mobj) and player.springmode then
		helpers.SquaredSlow(mobj, -1)
		return "FALL", A, A, B
    elseif mobj.sprite2 == SPR2_DRLN or mobj.sprite2 == SPR2_DRRN -- Slowable drift.
      helpers.SquaredSlow(mobj, -1)
      return "SPIN", A, A, D
	elseif (player.cmd.buttons & BT_BRAKE) and helpers.isMovingForward(mobj) and not helpers.isAirborne(mobj) then
		helpers.SquaredSlow(mobj, -1)
		return "SKID", A, A, A
	elseif ((player.speed >= machthreespeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
		helpers.SquaredSlow(mobj, -1)
		return "RUN_", A, A, D
	elseif helpers.isAirborne(mobj) and((player.speed <= machthreespeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
		helpers.SquaredSlow(mobj, -1)
		return "WALK", A, A, H
	elseif helpers.isAirborne(mobj) and((player.speed >= machthreespeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
		helpers.SquaredSlow(mobj, -1)
		return "RUN_", A, A, D
	elseif mobj.sprite2 == SPR2_SLWN then
		if helpers.isMovingForward(mobj) then
			helpers.SquaredSlow(mobj, -1)
			return "WALK", A, A, H
		else -- Moving sideways/backwards.
			if helpers.isMovingBackward(mobj) then
				helpers.SquaredSlow(mobj, 1)
				return "WALK", H, H, A
			end
		end
	elseif mobj.sprite2 == SPR2_STIL or player.ebrake then return "STIN", A, A, A
	end
  end
end

addHook("PlayerThink", function(sarbyluas) -- snick thok (stolen from my pizza tower pack)
	if sarbyluas.mo == nil then return end
	sarbyluas.thokspeed = 1
	if sarbyluas.mo.skin == "sarbysonictwo" then
		sarbyluas.thokspeed = FixedMul(sarbyluas.mo.scale, sarbyluas.thokspeed)
		if sarbyluas.thokspeed > 140*sarbyluas.mo.scale
			sarbyluas.thokspeed = 140*sarbyluas.mo.scale
		end
		if sarbyluas.thokspeed < 50*sarbyluas.mo.scale
			sarbyluas.thokspeed = 50*sarbyluas.mo.scale
		end
		if (sarbyluas.cmd.buttons & BT_LUAA) and sarbyluas.holdinh == 0 and sarbyluas.jumped == true and sarbyluas.snickthokked == false and not sarbyluas.fastfall and sarbyluas.spinouttimer <= 0 and sarbyluas.tumblebounces <= 0 and not sarbyluas.respawn.timer then -- if it works then it works
			P_InstaThrust(sarbyluas.mo, sarbyluas.mo.angle, (sarbyluas.thokspeed/2 + (FixedHypot(sarbyluas.rmomx, sarbyluas.rmomy))))
			S_StartSound(sarbyluas.mo, sfx_thok)
			local thok = P_SpawnMobj(sarbyluas.mo.x, sarbyluas.mo.y, sarbyluas.mo.z, MT_THOK)
			thok.color = sarbyluas.skincolor
			thok.scale = sarbyluas.mo.scale
			sarbyluas.snickthokked = true
		end
	end
end)

addHook("PlayerThink", function(sarbyluas) -- hello, is your name knuckles? that's fantastic.
	if sarbyluas.mo == nil then return end
	if sarbyluas.mo.skin == "sarbyknucklestwo" then
		if (sarbyluas.cmd.buttons & BT_LUAA) and sarbyluas.jumped == true and sarbyluas.yourefallingnow == false and sarbyluas.holdinh == 0 and not P_IsObjectOnGround(sarbyluas.mo) and sarbyluas.snickthokked == false and not sarbyluas.fastfall and sarbyluas.spinouttimer <= 0 and sarbyluas.tumblebounces <= 0 and not sarbyluas.respawn.timer then	
			sarbyluas.knuckleglided = true
			sarbyluas.jumped = true
			sarbyluas.yourefallingnow = false
		end
		if (sarbyluas.cmd.buttons & BT_LUAA) and sarbyluas.knuckleglided == true then
			sarbyluas.knuckleglided = true
			sarbyluas.yourefallingnow = true
		else
			sarbyluas.knuckleglided = false
		end
		if sarbyluas.knuckleglided == true and not sarbyluas.fastfall and sarbyluas.spinouttimer <= 0 and sarbyluas.tumblebounces <= 0 and not sarbyluas.respawn.timer then
			if (sarbyluas.mo.eflags & MFE_VERTICALFLIP) then
				sarbyluas.mo.momz = max(3*sarbyluas.mo.scale, 3*sarbyluas.mo.scale)
			else
				sarbyluas.mo.momz = max(-3*sarbyluas.mo.scale, -3*sarbyluas.mo.scale)
			end
			sarbyluas.mo.pitch = 0
			sarbyluas.mo.roll = 0
			if sarbyluas.speed >= 40*sarbyluas.mo.scale
				P_InstaThrust(sarbyluas.mo, sarbyluas.mo.angle, (FixedHypot(sarbyluas.rmomx, sarbyluas.rmomy)))
			else
				P_InstaThrust(sarbyluas.mo, sarbyluas.mo.angle, 30*sarbyluas.mo.scale)
			end
		end
		if sarbyluas.knuckleglided == true and sarbyluas.mo.eflags & MFE_JUSTBOUNCEDWALL
			sarbyluas.knuckleglided = false
			sarbyluas.yourefallingnow = false
			P_InstaThrust(sarbyluas.mo, sarbyluas.mo.angle, -10*sarbyluas.mo.scale)
			if (sarbyluas.mo.eflags & MFE_VERTICALFLIP) then
				sarbyluas.mo.momz = -18*sarbyluas.mo.scale
			else
				sarbyluas.mo.momz = 18*sarbyluas.mo.scale
			end
		end
	end
end)

addHook("PlayerThink", function(sarbyluas) -- the jump
	if sarbyluas.mo == nil then return end
	if sarbyluas.mo.skin == "sarbysonictwo" or sarbyluas.mo.skin == "sarbyknucklestwo" then
		if P_IsObjectOnGround(sarbyluas.mo) and sarbyluas.fastfall and sarbyluas.itemtype == KITEM_BUBBLESHIELD then
			sarbyluas.snickthokked = false
			sarbyluas.springmode = false
			sarbyluas.knuckleglided = false
			sarbyluas.flytimer = 480
		end
		if P_IsObjectOnGround(sarbyluas.mo) and sarbyluas.fastfall and sarbyluas.itemtype ~= KITEM_BUBBLESHIELD then
			sarbyluas.snickthokked = false
			sarbyluas.fastfall = 0
			sarbyluas.springmode = false
			sarbyluas.knuckleglided = false
			sarbyluas.flytimer = 480
		end
		if P_IsObjectOnGround(sarbyluas.mo) and not sarbyluas.fastfall then
			sarbyluas.snickthokked = false
			sarbyluas.jumped = false
			sarbyluas.springmode = false
			sarbyluas.knuckleglided = false
			sarbyluas.flytimer = 480
			sarbyluas.yourefallingnow = false
			sarbyluas.abletofangbounce = true
		end
		if (sarbyluas.cmd.buttons & BT_LUAA) and not (sarbyluas.cmd.buttons & BT_DRIFT) and not sarbyluas.fangbouncemode == true and not sarbyluas.fastfall and P_IsObjectOnGround(sarbyluas.mo) and not (sarbyluas.mo.colorized == true and sarbyluas.mo.color == SKINCOLOR_CYAN) and sarbyluas.spinouttimer <= 0 and sarbyluas.tumblebounces <= 0 and not sarbyluas.respawn.timer then -- this code makes you jump
			if (sarbyluas.mo.eflags & MFE_VERTICALFLIP) then
				S_StartSound(sarbyluas.mo, sfx_jump)
				sarbyluas.mo.momz = -16*sarbyluas.mo.scale
				sarbyluas.jumped = true
			else
				S_StartSound(sarbyluas.mo, sfx_jump)
				sarbyluas.mo.momz = 16*sarbyluas.mo.scale
				sarbyluas.jumped = true
			end
		end
	end
end)


addHook("PlayerThink", function(sarbyluas) -- this checks for if youre holding jump
	if sarbyluas.mo == nil then return end
	if sarbyluas.mo.skin == "sarbysonictwo" or sarbyluas.mo.skin == "sarbyknucklestwo" then
		if (sarbyluas.cmd.buttons & BT_LUAA) then
			sarbyluas.holdinh = 1 
		else
			sarbyluas.holdinh = 0
		end
	end
end)


addHook("PlayerThink", function(sarbyluas) -- this checks for SPRING MODE. IM TIRED OF ALL THESE STUPID COMMENTS SAYING CHECKING FOR JUMP
	if sarbyluas.mo == nil then return end
	if sarbyluas.mo.skin == "sarbysonictwo" or sarbyluas.mo.skin == "sarbyknucklestwo" then
		if sarbyluas.springstars or (sarbyluas.trickpanel != 0) then
			sarbyluas.springmode = true
			sarbyluas.jumped = false
		end
	end
end)

local function sarbyCollisionStuff(p2, p1)
	if p1.valid and p2.valid and p1.type == MT_PLAYER then
		if (p1.player.mo.skin == "sarbysonictwo" or p1.player.mo.skin == "sarbyknucklestwo") and p1 ~= p2 then
			if p1.player.jumped == true then
				if (p1.z <= p2.z + p2.height) and (p1.z + p1.height >= p2.z) then
					if p2.type == MT_PLAYER then
						P_DamageMobj(p2, p1, p1, 1, DMG_NORMAL)
					elseif p2.type == MT_BATTLECAPSULE then
						P_DamageMobj(p2, p1, p1, 9999, DMG_NORMAL)
					elseif p2.type == MT_BATTLEUFO then
						P_DamageMobj(p2, p1, p1, 9999, DMG_NORMAL)
					elseif p2.type == MT_SPECIAL_UFO then
						P_DamageMobj(p2, p1, p1, 1, DMG_NORMAL)
					end
					if (p1.eflags & MFE_VERTICALFLIP) then
						p1.momz = -16*p1.scale
					else
						p1.momz = 16*p1.scale
					end
				end
			end
		end
	end
end

addHook("MobjCollide", sarbyCollisionStuff, MT_PLAYER)
addHook("MobjCollide", sarbyCollisionStuff, MT_BATTLECAPSULE)
addHook("MobjCollide", sarbyCollisionStuff, MT_BATTLEUFO)
addHook("MobjCollide", sarbyCollisionStuff, MT_SPECIAL_UFO)